program colbuild;
{$INCLUDE colbuild.inc}
{$APPTYPE CONSOLE}

uses
  SysUtils,
  janStrings in 'janXMLParser2\janstrings.pas',
  janXMLParser2 in 'janXMLParser2\janXMLParser2.pas',
  janXPathTokenizer in 'janXMLParser2\janXPathTokenizer.pas',
  uFunc in 'uFunc.pas',
  uMain in 'uMain.pas',
  uCollectionDef in 'uCollectionDef.pas',
  uFileList in 'uFileList.pas',
  RegExpr in 'regexpr\RegExpr.pas',
  uProcess in 'uProcess.pas',
  uConfig in 'uConfig.pas',
  uStrings in 'uStrings.pas';

procedure SyntaxError(const Msg: string = '');
  begin
    Writeln(HEADER + Msg);
    Halt(1);
  end;

var BadIndex: integer;
    Msg: string;

begin
  with TCollectionBuilder.Create do
    try
      try
        if not Config.LoadFromCommandLine(BadIndex, Msg) then
          SyntaxError(Format(SYNTAX_ERROR, [BadIndex, ParamStr(BadIndex), Msg, Config.CommandLineSyntax]))
        else if (Config.PlaylistDefinitionFileName = '') and (Config.CollectionRegexp = '') then
          SyntaxError(Format(PLAYLIST_ERROR1, [Config.CommandLineSyntax]))
        else if (Config.PlaylistDefinitionFileName <> '') and (not FileExists(Config.PlaylistDefinitionFileName)) then
          SyntaxError(Format(PLAYLIST_ERROR2, [Config.PlaylistDefinitionFileName, Config.CommandLineSyntax]))
        else
          Execute;
      except
        on E: Exception do
          begin
          Writeln(HEADER + Format(EXCEPTION_ERROR, [E.ClassName, E.Message]));
          Halt(2);
          end;
        end;
    finally
      Free;
      end;
end.
